%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [CM_Flag, K_T_Data, K_R_Data] = Get_Bearing_Stiffnesses(Fastener_Index, Layer, Axis_Point_1, Axis_Point_2, Oriented_Axis_vector, Ref_Dir_Vector)

global ErrCode;

global DB_ELEMENTS;
global DB_PSETS;
global DB_MATERIALS;

global AT_ELEMENTS;
global AT_PSETS;
global AT_MATERIALS;

global DB_FASTENERS;

CM_Flag = [];
K_T_Data = [];
K_R_Data = [];

% Ветвление по типу присоединенной топологии
switch DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}

    case {'plate', 'rbe2_2d_hole', 'bar_spider_2d_hole', 'plate_rbe2_sequential', 'plate_rbe2_parallel'}
        
        pset_type = DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.type;
        
        switch pset_type
            
            case {'PCOMP', 'PCOMPG'}
                
                CM_Flag = 1;
                
            case 'PSHELL'
                
                % Проверка типа материала
                mat_type = DB_MATERIALS{AT_MATERIALS(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.Mat_ID_membrane)}.type;
                
                switch mat_type
                    case 'isotropic'
                        CM_Flag = 0;
                    case '2d_orthotropic'
                        CM_Flag = 1;
                    case '2d_anisotropic'
                        CM_Flag = 1;
                    otherwise
                        fprintf (1, '\nОшибка функции Get_Bearing_Stiffnesses: недопустимый тип материала [%s] среди элементов присоединенной топологии [%s] болта %i !\n', mat_type, DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}, Fastener_Index);
                        ErrCode = -1;
                        return;
                end
                
            otherwise
                
                fprintf (1, '\nОшибка функции Get_Bearing_Stiffnesses: недопустимый тип property set [%s] среди элементов присоединенной топологии [%s] болта %i !\n', pset_type, DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}, Fastener_Index);
                ErrCode = -1;
                return;
            
        end
        
        % --- Вычисление жесткостей ---
        
        if (CM_Flag == 0) % Пластина из изотропного материала
            
            % Входные параметры функции расчета жесткостей
            t = Get_Plate_Thickness(Fastener_Index, Layer, Axis_Point_1, Axis_Point_2);
            if (ErrCode < 0)
                return;
            end
            E_plate =  DB_MATERIALS{AT_MATERIALS(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.Mat_ID_membrane)}.E;
            nu_plate = DB_MATERIALS{AT_MATERIALS(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.Mat_ID_membrane)}.nu;
            E_fastener = DB_MATERIALS{AT_MATERIALS(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Shank_elements(1))}.Prop_ID)}.Mat_ID)}.E;

            % Расчет жесткостей
            [K_T, K_R] = Isotropic_Bearing_Stiffnesses(t, E_plate, nu_plate, E_fastener);

            % Заполнение выходных массивов
            K_T_Data = zeros(1,3);
            K_T_Data(1,1) = K_T;
            K_T_Data(1,2) = K_T;

            K_R_Data = zeros(1,3);
            K_R_Data(1,1) = K_R;
            K_R_Data(1,2) = K_R;
            
        else % Пластина из композита
            
            [K_T_Data, K_R_Data] = Composite_Bearing_Stiffnesses(Fastener_Index, Layer, Oriented_Axis_vector, Ref_Dir_Vector);
            
            if (ErrCode < 0)
                return;
            end
            
        end
        
    case {'rbe2_3d_hole', 'bar_spider_3d_hole'}

        % Проверка типа материала
        mat_type = DB_MATERIALS{AT_MATERIALS(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.Mat_ID)}.type;
        
        switch mat_type
            case 'isotropic'
                CM_Flag = 0;
            otherwise
                fprintf (1, '\nОшибка функции Get_Bearing_Stiffnesses: недопустимый тип материала [%s] среди элементов присоединенной топологии [%s] болта %i !\n', mat_type, DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}, Fastener_Index);
                ErrCode = -1;
                return;
        end
        
        % --- Вычисление жесткостей ---
        
        % Входные параметры функции расчета жесткостей
        t = Get_Plate_Thickness(Fastener_Index, Layer, Axis_Point_1, Axis_Point_2);
        if (ErrCode < 0)
            return;
        end
        E_plate =  DB_MATERIALS{AT_MATERIALS(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.Mat_ID)}.E;
        nu_plate = DB_MATERIALS{AT_MATERIALS(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.Mat_ID)}.nu;
        E_fastener = DB_MATERIALS{AT_MATERIALS(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Shank_elements(1))}.Prop_ID)}.Mat_ID)}.E;
        
        % Расчет жесткостей
        [K_T, K_R] = Isotropic_Bearing_Stiffnesses(t, E_plate, nu_plate, E_fastener);
        
        % Заполнение выходных массивов
        K_T_Data = zeros(1,3);
        K_T_Data(1,1) = K_T;
        K_T_Data(1,2) = K_T;
        
        K_R_Data = zeros(1,3);
        K_R_Data(1,1) = K_R;
        K_R_Data(1,2) = K_R;
        
    otherwise

        fprintf (1, '\nОшибка функции Get_Bearing_Stiffnesses: неизвестный тип присоединенной топологии [%s] в болте %i !\n', DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}, Fastener_Index);
        ErrCode = -1;
        return;

end
